{

(c) GNU General Public License
(c) 1995-99 by raVen //ULT

}
{&Use32+}
unit BackDos;

interface

uses
  Objects, Views, App, Drivers, Memory;

type
  PDosBackground = ^TDosBackground;
  TDosBackground = object(TBackGround)
    constructor Init(var Bounds: TRect);
    procedure Draw; virtual;
    constructor Load(var S: TStream);
    procedure Store(var S: TStream);
    destructor Done; virtual;
    function Valid(Command: Word): Boolean; virtual;
  private
    Buffer: Pointer;
    procedure InitBuf;
  end;

  PDosBackDesk = ^TDosBackDesk;
  TDosBackDesk = object(TDesktop)
    procedure InitBackground; virtual;
  end;

  PDosBackApp = ^TDosBackApp;
  TDosBackApp = object(TApplication)
    procedure InitDesktop; virtual;
  end;

const
  RDosBackground: TStreamRec = (
    ObjType: 1002;
    VMTLink: Word(TypeOf(TDosBackground));
    Load: @TDosBackground.Load;
    Store: @TDosBackground.Store
  );

implementation

procedure TDosBackground.InitBuf;
begin
  Buffer := MemAlloc(ScreenHeight*ScreenWidth*2);
  HideMouse;
  if Buffer <> nil then Move(ScreenBuffer^, Buffer^, ScreenHeight*ScreenWidth*2);
  ShowMouse;
end;

constructor TDosBackground.Init;
begin
  TView.Init(Bounds);
  InitBuf;
end;

procedure TDosBackground.Draw;
begin
  WriteBuf(0, 0, ScreenWidth, ScreenHeight, Buffer^);
end;

constructor TDosBackground.Load;
begin
  TView.Load(S);
  InitBuf;
end;

procedure TDosBackground.Store;
begin
  TView.Store(S);
end;

destructor TDosBackground.Done;
begin
  HideMouse;
  if Buffer <> nil then
    Move(Buffer^, ScreenBuffer^, ScreenHeight*ScreenWidth*2);
  ShowMouse;
  FreeMem(Buffer, ScreenHeight*ScreenWidth*2);
  inherited Done;
end;

function TDosBackground.Valid;
var
  T: Boolean;
begin
  T := inherited Valid(Command);
  Valid := T;
  if T then
    if Command = cmValid then
      Valid := Buffer <> nil;
end;

procedure TDosBackDesk.InitBackground;
var
  R: TRect;
begin
  GetExtent(R);
  Background := New(PDosBackground, Init(R));
end;

procedure TDosBackApp.InitDesktop;
var
  R: TRect;
begin
  GetExtent(R);
  GetExtent(R);
  Inc(R.A.Y);
  Dec(R.B.Y);
  Desktop := New(PDosBackDesk, Init(R));
end;

end.
